#ifndef WINDOW_H
#define WINDOW_H

#include <QWindow>
#include <QDebug>
#include <QKeyEvent>
#include <QtStudio3D/Q3DSPresentation>
#include <QTimer>
#include <QObject>
class Window : public QWindow
{
    Q_OBJECT
public:
    explicit Window(QWindow *parent = nullptr);

    void setPresentation(Q3DSPresentation* presentation)
    {
        if (presentation == nullptr)
        {
            qDebug() << "presentation is null";
            return;
        }
        m_presentation = presentation;
        qDebug() << "presentation ready";
        connect(m_presentation,  &Q3DSPresentation::slideEntered,
                [this] (const QString &elementPath, unsigned int index, const QString &name)
        {
            if (elementPath == "Scene")
            {
                onSlideEntered2();
            }
        });

    }


    void onSlideEntered2()
    {
        static int countOfSlideEntered = 0;
        if (countOfSlideEntered < 2) { // QT3DS-4217 workaround
        qDebug() << "slide entered";
        m_presentation->setDataInputValue("CurrentPage", QString("PermanentPage"));
        m_presentation->setDataInputValue("OrthogonalLayerVisible", QVariant(true), true);
        m_presentation->setDataInputValue("FuelLevelVisible", QVariant(true), true);
        m_presentation->setDataInputValue("FuelLevelTimeline", QVariant(0.1f), true);
        countOfSlideEntered++;
        }
    }

protected:
    virtual void keyPressEvent(QKeyEvent *event)
    {
        if (m_presentation == nullptr)
        {
            return;
        }
        qDebug() << event->key() - 48 << "pressed";

        switch(event->key())
        {
        case Qt::Key_1:
        m_presentation->setDataInputValue("FuelLevelTimeline", QVariant(0.1f), true);
            break;
        }
    }

private:
    Q3DSPresentation* m_presentation;
    float m_levelTimeLine;
};

#endif // WINDOW_H



//    void onSlideEntered()
//    {
//        static bool firstSlideEntered = false;
//        if (!firstSlideEntered) {
//        qDebug() << "slide entered";
//        m_presentation->setDataInputValue("CurrentPage", QString("PermanentPage"));
//        m_presentation->setDataInputValue("OrthogonalLayerVisible", QVariant(true), true);
//        m_presentation->setDataInputValue("FuelLevelVisible", QVariant(true), true);
//        m_presentation->setDataInputValue("FuelLevelTimeline", QVariant(0.1f), true);
//        firstSlideEntered = true;
//        }
//    }
