#include <QGuiApplication>
#include <QWindow>
#include <QtStudio3D/Q3DSViewerSettings>
#include <QtStudio3D/Q3DSPresentation>
#include <QtStudio3D/Q3DSSurfaceViewer>
#include <QOpenGLContext>
#include <QDebug>
#include "Window.h"
#include <QObject>

int main(int argc, char *argv[])
{
    QGuiApplication app(argc, argv);
    QSize size(800,480);
    Window window;

    window.resize(size);
    window.setSurfaceType(QSurface::OpenGLSurface);
    window.create();
    Q3DSSurfaceViewer viewer;
    QOpenGLContext context;

    context.setFormat(window.format());
    context.create();

    QObject::connect(&viewer, &Q3DSSurfaceViewer::presentationReady, [&window, &viewer]()
    {
        window.setPresentation(viewer.presentation());
    });
    QObject::connect(&viewer, &Q3DSSurfaceViewer::presentationLoaded, [&window, &viewer]()
    {
        qDebug() << "presentation loaded";
    });
    viewer.presentation()->setSource(QUrl(QStringLiteral("qrc:/ClusterMain.uia")));
    viewer.setUpdateInterval(0);
    viewer.settings()->setShowRenderStats(false);
    viewer.settings()->setScaleMode(Q3DSViewerSettings::ScaleModeCenter);
    viewer.create(&window, &context);





    window.show();



    return app.exec();
}
